#import <Cocoa/Cocoa.h>

#import "KFTypeSelectTableView.h"

@class XeeDirectoryController;

@interface XeeDestinationView:KFTypeSelectTableView
{
	NSTableColumn *colorcolumn;

	BOOL outside,suggest_outside;

	IBOutlet XeeDirectoryController *controller;
}

-(void)dealloc;
-(void)awakeFromNib;
-(void)drawRow:(int)row clipRect:(NSRect)clipRect;
-(void)mouseDown:(NSEvent *)event;
-(void)menuForEvent:(NSEvent *)event;
-(void)keyDown:(NSEvent *)event;
-(unsigned int)draggingSourceOperationMaskForLocal:(BOOL)local;
-(void)dragImage:(NSImage *)image at:(NSPoint)loc offset:(NSSize)offset event:(NSEvent *)event pasteboard:(NSPasteboard *)pboard source:(id)src slideBack:(BOOL)slide;
-(NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender;
-(void)draggingExited:(id <NSDraggingInfo>)sender;
-(void)draggedImage:(NSImage *)draggedImage movedTo:(NSPoint)screenPoint;
-(void)draggedImage:(NSImage *)image endedAt:(NSPoint)point operation:(NSDragOperation)op;
-(void)updateData:(id)notification;

-(IBAction)openInXee:(id)sender;
-(IBAction)openInFinder:(id)sender;
-(IBAction)removeFromList:(id)sender;

@end



@interface XeeDestinationListHandler:NSObject
{
	NSMutableArray *destinations;
	NSIndexSet *lastrowset;
}

-(id)init;
-(id)tableView:(NSTableView *)table objectValueForTableColumn:(NSTableColumn *)column row:(int)row;
-(int)numberOfRowsInTableView:(NSTableView *)table;
-(BOOL)tableView:(NSTableView *)table writeRowsWithIndexes:(NSIndexSet *)rows toPasteboard:(NSPasteboard*)pboard;
-(NSDragOperation)tableView:(NSTableView*)table validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)op;
-(BOOL)tableView:(NSTableView*)table acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)op;
//-(float)tableView:(NSTableView *)tableView heightOfRow:(int)row;
-(void)deleteLastRows;
-(void)suggestInsertion:(NSString *)directory;
-(void)addDestinations:(NSArray *)directories index:(int)index;
-(int)findDestination:(NSString *)directory;
-(void)removeDestination:(int)index;
-(NSDictionary *)destination:(int)index;
-(void)updateTables;
-(void)saveList;

+(XeeDestinationListHandler *)defaultObject;

@end
